/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.sun.mojarra.scales.component;

import com.sun.mojarra.scales.util.ScalesUtil;
import java.io.IOException;
import javax.faces.component.UIOutput;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;

/**
 *
 * @author jasonlee
 */
public class LayoutUnit extends UIOutput {

    public static final String COMPONENT_FAMILY = "com.sun.mojarra.scales.LayoutUnit";
    public static final String COMPONENT_TYPE = COMPONENT_FAMILY;
    public static final String RENDERER_TYPE = COMPONENT_FAMILY;
    private Object[] _state = null;
    
    protected String position;
    protected String header;
    protected Integer width;
    protected Integer height;
    protected Boolean resize;
    protected String gutter;
    protected String footer;
    protected Boolean collapse;
    protected Boolean scroll;
    protected String body;
    protected Boolean animate;
    protected Integer minWidth;
    protected Integer maxWidth;
    protected Integer minHeight;
    protected Integer maxHeight;
    protected String style;
    protected String styleClass;

    public LayoutUnit() {
        super();
        setRendererType(RENDERER_TYPE);
    }

    @Override
    public String getFamily() {
        return COMPONENT_FAMILY;
    }

    @Override
    public void encodeBegin(FacesContext context) throws IOException {
        super.encodeBegin(context);

        if (!isRendered()) {
            return;
        }

        ResponseWriter writer = context.getResponseWriter();
        writer.startElement("div", this);
        writer.writeAttribute("id", getClientId(context), "id");
        writer.writeAttribute("class", getStyleClass(), "class");
        writer.writeAttribute("style", "visibility: hidden; " + getStyle(), "style");
    }

    @Override
    public void encodeEnd(FacesContext context) throws IOException {
        super.encodeEnd(context);
        
        if (!isRendered()) {
            return;
        }

        ResponseWriter writer = context.getResponseWriter();
        writer.endElement("div");
        writer.write("\n");
    }

    @Override
    public boolean getRendersChildren() {
        return false;
    }

    public Boolean getAnimate() {
        return ScalesUtil.getPropertyValue(this, animate, "animate", Boolean.TRUE);
    }

    public void setAnimate(Boolean animate) {
        this.animate = animate;
    }

    public String getBody() {
        return ScalesUtil.getPropertyValue(this, body, "body", null);
    }

    public void setBody(String body) {
        this.body = body;
    }

    public Boolean getCollapse() {
        return ScalesUtil.getPropertyValue(this, collapse, "collapse", Boolean.FALSE);
    }

    public void setCollapse(Boolean collapse) {
        this.collapse = collapse;
    }

    public String getFooter() {
        return ScalesUtil.getPropertyValue(this, footer, "footer", null);
    }

    public void setFooter(String footer) {
        this.footer = footer;
    }

    public String getGutter() {
        return ScalesUtil.getPropertyValue(this, gutter, "gutter", "5px");
    }

    public void setGutter(String gutter) {
        this.gutter = gutter;
    }

    public String getHeader() {
        return ScalesUtil.getPropertyValue(this, header, "header", null);
    }

    public void setHeader(String header) {
        this.header = header;
    }

    public Integer getHeight() {
        return ScalesUtil.getPropertyValue(this, height, "height", null);
    }

    public void setHeight(Integer height) {
        this.height = height;
    }

    public Integer getMaxHeight() {
        return ScalesUtil.getPropertyValue(this, maxHeight, "maxHeight",  null);
    }

    public void setMaxHeight(Integer maxHeight) {
        this.maxHeight = maxHeight;
    }

    public Integer getMaxWidth() {
        return ScalesUtil.getPropertyValue(this, maxWidth, "maxWidth", null);
    }

    public void setMaxWidth(Integer maxWidth) {
        this.maxWidth = maxWidth;
    }

    public Integer getMinHeight() {
        return ScalesUtil.getPropertyValue(this, minHeight, "minHeight", null);
    }

    public void setMinHeight(Integer minHeight) {
        this.minHeight = minHeight;
    }

    public Integer getMinWidth() {
        return ScalesUtil.getPropertyValue(this, minWidth, "minWidth", null);
    }

    public void setMinWidth(Integer minWidth) {
        this.minWidth = minWidth;
    }

    public String getPosition() {
        return ScalesUtil.getPropertyValue(this, position, "position", null);
    }

    public void setPosition(String position) {
        this.position = position;
    }

    public Boolean getResize() {
        return ScalesUtil.getPropertyValue(this, resize, "resize", Boolean.FALSE);
    }

    public void setResize(Boolean resize) {
        this.resize = resize;
    }

    public Boolean getScroll() {
        return ScalesUtil.getPropertyValue(this, scroll, "scroll", Boolean.TRUE);
    }

    public void setScroll(Boolean scroll) {
        this.scroll = scroll;
    }

    public String getStyle() {
        return ScalesUtil.getPropertyValue(this, style, "style", "");
    }

    public void setStyle(String style) {
        this.style = style;
    }

    public String getStyleClass() {
        return ScalesUtil.getPropertyValue(this, styleClass, "styleClass", "");
    }

    public void setStyleClass(String styleClass) {
        this.styleClass = styleClass;
    }

    public Integer getWidth() {
        return ScalesUtil.getPropertyValue(this, width, "width", null);
    }

    public void setWidth(Integer width) {
        this.width = width;
    }

    @Override
    public Object saveState(FacesContext context) {
        if (_state == null) {
            _state = new Object[18];
        }
        _state[0] = super.saveState(context);
        _state[1] = position;
        _state[2] = header;
        _state[3] = width;
        _state[4] = height;
        _state[5] = resize;
        _state[6] = gutter;
        _state[7] = footer;
        _state[8] = collapse;
        _state[9] = scroll;
        _state[10] = body;
        _state[11] = animate;
        _state[12] = minWidth;
        _state[13] = maxWidth;
        _state[14] = minHeight;
        _state[15] = maxHeight;
        _state[16] = style;
        _state[17] = styleClass;
        return _state;
    }

    @Override
    public void restoreState(FacesContext context, Object state) {
        this._state = (Object[]) state;
        super.restoreState(context, this._state[0]);
        position = (String) this._state[1];
        header = (String) this._state[2];
        width = (Integer) this._state[3];
        height = (Integer) this._state[4];
        resize = (Boolean) this._state[5];
        gutter = (String) this._state[6];
        footer = (String) this._state[7];
        collapse = (Boolean) this._state[8];
        scroll = (Boolean) this._state[9];
        body = (String) this._state[10];
        animate = (Boolean) this._state[11];
        minWidth = (Integer) this._state[12];
        maxWidth = (Integer) this._state[13];
        minHeight = (Integer) this._state[14];
        maxHeight = (Integer) this._state[15];
        style = (String) this._state[16];
        styleClass = (String) this._state[17];
    }
}