/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.sun.mojarra.scales.component;

import com.sun.mojarra.scales.util.RenderingHelper;
import java.io.IOException;
import java.util.Map;
import javax.faces.component.UIInput;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;

/**
 *
 * @author jasonlee
 */
public class ScalesInputComponent extends UIInput {

    protected String templateFile;
    protected static final String CHILD_COMP_MARKER = "___children___";
    protected String templateText;

    @Override
    public void encodeBegin(FacesContext context) throws IOException {
        if (templateFile == null) {
            super.encodeBegin(context);
            return;
        }
        if (context == null) {
            throw new NullPointerException("param 'context' is null");
        }

        // suppress rendering if "rendered" property on the component is false.
        if (!isRendered()) {
            return;
        }
        templateText = RenderingHelper.loadTemplateText(this, templateFile);
        ResponseWriter writer = context.getResponseWriter();
        String beforeText = RenderingHelper.getBeforeText(templateText);
        writer.write(beforeText);
    }

    @Override
    public void encodeEnd(FacesContext context) throws IOException {
        if (templateFile == null) {
            super.encodeEnd(context);
            return;
        }
        ResponseWriter writer = context.getResponseWriter();
        String afterText = RenderingHelper.getAfterText(templateText);
        writer.write(afterText);
    }

    @Override
    public boolean getRendersChildren() {
        if (templateFile == null) {
            return super.getRendersChildren();
        } else {
            return false;
        }
    }

    protected void setTemplateFile(String fileName) {
        this.templateFile = fileName;
    }

    @Override
    public void decode(FacesContext facesContext) {
        Map requestMap = facesContext.getExternalContext().getRequestParameterMap();
        String clientId = getClientId(facesContext);

        String string_submit_val = ((String) requestMap.get(clientId));

        setSubmittedValue(string_submit_val);
    }
}
