/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 * 
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 * 
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common Development
 * and Distribution License("CDDL") (collectively, the "License").  You
 * may not use this file except in compliance with the License. You can obtain
 * a copy of the License at https://glassfish.dev.java.net/public/CDDL+GPL.html
 * or glassfish/bootstrap/legal/LICENSE.txt.  See the License for the specific
 * language governing permissions and limitations under the License.
 * 
 * When distributing the software, include this License Header Notice in each
 * file and include the License file at glassfish/bootstrap/legal/LICENSE.txt.
 * Sun designates this particular file as subject to the "Classpath" exception
 * as provided by Sun in the GPL Version 2 section of the License file that
 * accompanied this code.  If applicable, add the following below the License
 * Header, with the fields enclosed by brackets [] replaced by your own
 * identifying information: "Portions Copyrighted [year]
 * [name of copyright owner]"
 * 
 * Contributor(s):
 * 
 * If you wish your version of this file to be governed by only the CDDL or
 * only the GPL Version 2, indicate your decision by adding "[Contributor]
 * elects to include this software in this distribution under the [CDDL or GPL
 * Version 2] license."  If you don't indicate a single choice of license, a
 * recipient has the option to distribute your version of this file under
 * either the CDDL, the GPL Version 2 or to extend the choice of license to
 * its licensees as provided above.  However, if you add GPL Version 2 code
 * and therefore, elected the GPL Version 2 license, then the option applies
 * only if the new code is made subject to such option by the copyright
 * holder.
 */

/**
 * 
 */
package com.sun.mojarra.scales.util;

/**
 * This class is a holder for <code>private static final String</code>s for various
 * YUI-related file names and paths.
 * @author Jason Lee
 *
 */
public class YuiConstants {
    public static final String YUI_ROOT                 = "/yui/";
    public static final String SCALES_ROOT              = "/scales/";
    
    // During development, this could/should be set to "-debug" but set to "-min" for a production build.
    // Doing it this way makes it really easy to forget to change when preparing a production build, but calling a 
    // method to the get JS file name seems a bit heavy to me.  There are probably other/better ways to handle this, 
    // and I'll likely revisit this at some point, but, right now, this is how it is. :P  It *is* open source... ;)
    public static final String YUI_SUFFIX               = "-min";

    //***********************************************************************************************************
    // CSS
    //***********************************************************************************************************
    public static final String CSS_SKIN_SAM               = YUI_ROOT + "assets/skins/sam/skin.css";
    public static final String CSS_RESIZE                 = YUI_ROOT + "assets/skins/sam/resize.css";
    public static final String CSS_LAYOUT                 = YUI_ROOT + "assets/skins/sam/layout.css";
    public static final String CSS_COLOR_PICKER           = YUI_ROOT + "assets/skins/sam/colorpicker.css";
    public static final String CSS_RESET_FONTS_GRIDS      = YUI_ROOT + "reset-fonts-grids/reset-fonts-grids.css";
    public static final String CSS_SCALES                 = SCALES_ROOT + "scales.css";


    //***********************************************************************************************************
    // YUI JavaScript
    //***********************************************************************************************************
    public static final String JS_BUTTON                   = YUI_ROOT + "button/button" + YUI_SUFFIX + ".js";
    public static final String JS_CALENDAR                 = YUI_ROOT + "calendar/calendar" + YUI_SUFFIX + ".js";
    public static final String JS_CAROUSEL                 = YUI_ROOT + "carousel/carousel" + YUI_SUFFIX + ".js";
    public static final String JS_CHARTS                   = YUI_ROOT + "charts/charts" + YUI_SUFFIX + ".js";
    public static final String JS_COLORPICKER              = YUI_ROOT + "colorpicker/colorpicker" + YUI_SUFFIX + ".js";
    public static final String JS_CONTAINER                = YUI_ROOT + "container/container" + YUI_SUFFIX + ".js";
    public static final String JS_COOKIE                   = YUI_ROOT + "cookie/cookie-beta" + YUI_SUFFIX + ".js";
    public static final String JS_DATASOURCE               = YUI_ROOT + "datasource/datasource" + YUI_SUFFIX + ".js";
    public static final String JS_EDITOR                   = YUI_ROOT + "editor/editor" + YUI_SUFFIX + ".js";
    public static final String JS_LAYOUT                   = YUI_ROOT + "layout/layout" + YUI_SUFFIX + ".js";
    public static final String JS_LOGGER                   = YUI_ROOT + "logger/logger" + YUI_SUFFIX + ".js";
    public static final String JS_JSON                     = YUI_ROOT + "json/json" + YUI_SUFFIX + ".js";
    public static final String JS_MENU                     = YUI_ROOT + "menu/menu" + YUI_SUFFIX + ".js";
    public static final String JS_RESIZE                   = YUI_ROOT + "resize/resize" + YUI_SUFFIX + ".js";
    public static final String JS_SLIDER                   = YUI_ROOT + "slider/slider" + YUI_SUFFIX + ".js";
    public static final String JS_TABVIEW                  = YUI_ROOT + "tabview/tabview" + YUI_SUFFIX + ".js";
    public static final String JS_TREEVIEW                 = YUI_ROOT + "treeview/treeview" + YUI_SUFFIX + ".js";
    /*
     * Yahoo Global Object
     * Event
     * Dom
     * Connection Manager
     * Animation
     * Drag & Drop
     * Element
     * Get
     * YUI Loader
     */
    public static final String JS_UTILITES                 = YUI_ROOT + "utilities/utilities.js";
    
    //***********************************************************************************************************
    // Helper JavaScript
    //***********************************************************************************************************
    public static final String JS_DATESELECTOR_HELPER      = SCALES_ROOT + "dateselector_helper.js";
    public static final String JS_SCALES                   = SCALES_ROOT + "scales.js";
    public static final String JS_TREEVIEW_HELPER          = SCALES_ROOT + "treeview_helper.js";
    public static final String JS_UPLOADER_HELPER          = SCALES_ROOT + "upload_helper.js";

    //***********************************************************************************************************
    // Other
    //***********************************************************************************************************
    public static final String OTHER_CHART_FLASH           = YUI_ROOT + "charts/assets/charts.swf";
}